> ## Documentation Index
> Fetch the complete documentation index at: https://api.aodocs.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Post documenttypev1libraries documenttypes ossfield



## OpenAPI

````yaml /openapis/documentType.json post /documentType/v1/libraries/{libraryId}/documentTypes/{classId}/ossField
openapi: 3.0.1
info:
  description: "The AODocs REST API exposes most of the features of AODocs. It can be used to implement custom applications, third-party integration, bulk tools, or\n\t\t\t\t\t\t\t\t\t\tjust to experiment with AODocs."
  version: 69.20.1
  title: AODocs REST API
servers:
  - url: https://aodocs.altirnao.com/api
security: []
tags:
  - name: documentType
    description: >-
      Lets you manipulate existing document classes (beta version, subject to
      change)
paths:
  /documentType/v1/libraries/{libraryId}/documentTypes/{classId}/ossField:
    post:
      tags:
        - documentType
      operationId: documentType:v1beta1.DocumentType.setOssField
      parameters:
        - $ref: '#/components/parameters/libraryId_path_parameter'
        - name: classId
          in: path
          description: The ID of the document class
          required: true
          schema:
            type: string
        - name: remove
          in: query
          required: false
          schema:
            type: boolean
            default: false
        - $ref: '#/components/parameters/domain_query_parameter'
      responses:
        '200':
          description: A ApiClassField response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiClassField'
      security:
        - google_id_token-a99f12e0:
            - https://www.googleapis.com/auth/userinfo.email
        - google_id_token_legacy-a99f12e0:
            - https://www.googleapis.com/auth/userinfo.email
components:
  parameters:
    libraryId_path_parameter:
      name: libraryId
      in: path
      description: The ID of the library
      required: true
      schema:
        type: string
    domain_query_parameter:
      name: domain
      in: query
      description: The G Suite domain
      required: false
      schema:
        type: string
  schemas:
    ApiClassField:
      type: object
      properties:
        appMetadata:
          type: object
          description: >-
            App Metadata let developers associate metadata with various
            configuration entities. The metadata is isolated within app
            namespaces in order to prevent one application from interfering with
            another's metadata.
          additionalProperties:
            $ref: '#/components/schemas/ApiNamespacedAppMetadata'
        calculatedSettings:
          type: object
          description: The configuration of calculated settings (mandatory/hidden)
          additionalProperties:
            $ref: '#/components/schemas/ApiCalculatedSettingConfiguration'
        calculatedValue:
          $ref: '#/components/schemas/ApiCalculatedValueConfiguration'
        categoryDefinition:
          $ref: '#/components/schemas/ApiCategoryDefinition'
        categoryId:
          type: string
          description: >-
            The ID of the category (if type = CATEGORY) - (deprecated,
            read-only)
        categoryValueMapping:
          $ref: '#/components/schemas/ApiCategoryValueMappingRef'
        columns:
          type: array
          description: >-
            The column properties of the field (only if this field is a table
            type field)
          items:
            $ref: '#/components/schemas/ApiClassTableColumn'
        creationSettings:
          $ref: '#/components/schemas/ApiDocumentFieldFlags'
        customPlaceholder:
          type: boolean
          description: >-
            Whether to use a custom placeholder when displaying the field in the
            UI
        description:
          type: string
          description: The description of the field
        displayInPreview:
          type: object
          description: The display in preview configuration of the field
          additionalProperties:
            $ref: '#/components/schemas/ApiDisplayInPreviewConfiguration'
        displayName:
          type: string
          description: The name of the field
        dynamicValues:
          type: boolean
        folder:
          type: boolean
        hidden:
          type: boolean
          description: >-
            Whether the field should be hidden for the whole life-cycle of
            documents of the class
        id:
          type: string
          description: The ID of the field (read-only field)
        kind:
          type: string
        levelNames:
          type: array
          items:
            type: string
        lookupConfiguration:
          $ref: '#/components/schemas/ApiLookupConfiguration'
        mandatory:
          type: boolean
          description: >-
            Whether the field should be mandatory for the whole life-cycle of
            documents of the class (not compatible for all field types)
        mappingSourceField:
          $ref: '#/components/schemas/ApiFieldRef'
        multiple:
          type: boolean
          description: >-
            Whether the field should be multi-valued (not compatible for all
            field types)
        placeholderText:
          type: string
          description: The placeholder text if customPlaceholder = true
        rank:
          type: integer
          format: int32
          description: The rank of the field in the list (deprecated)
        readOnly:
          type: boolean
          description: >-
            Whether the field should be read-only for the whole life-cycle of
            documents of the class (not compatible for all field types)
        referenceCatalog:
          $ref: '#/components/schemas/ApiReferenceCatalog'
        referenceCatalogId:
          type: string
          description: The ID of the reference catalog (if type = REFERENCE_CATALOG)
        type:
          type: string
          description: >-
            The type of field (STRING, TEXT, DATE, TIME, DATETIME, INTEGER,
            DECIMAL, BOOLEAN, PERSON, GEOPOINT, URL, CATEGORY,
            REFERENCE_CATALOG, TABLE)
          enum:
            - STRING
            - TEXT
            - DATE
            - TIME
            - DATETIME
            - INTEGER
            - FILESIZE
            - DECIMAL
            - BOOLEAN
            - PERSON
            - CATEGORY
            - GEOPOINT
            - URL
            - REFERENCE_CATALOG
            - MIMETYPEGROUP
            - CLASS
            - FOLDER
            - STATE
            - OSS_ATTACHMENT
            - DRIVE_ATTACHMENT
            - TABLE
        validation:
          $ref: '#/components/schemas/ApiFieldValidation'
    ApiNamespacedAppMetadata:
      type: object
      properties:
        appNamespaceId:
          type: string
          description: The id of the app namespace (read-only)
        kind:
          type: string
        tags:
          type: array
          description: The list of tags (name/value) in the namespace (limited to 10 items)
          items:
            $ref: '#/components/schemas/ApiAppMetadataTag'
    ApiCalculatedSettingConfiguration:
      type: object
      properties:
        code:
          type: string
          description: >-
            JavaScript expression in charge of generating the actual value of
            the setting (ECMAScript 2020)
        fallbackValues:
          type: array
          description: >-
            Fallback value(s) used when there was evaluation error on the
            calculated setting
          items:
            type: string
    ApiCalculatedValueConfiguration:
      type: object
      properties:
        code:
          type: string
          description: >-
            JavaScript expression in charge of generating document field values
            (ECMAScript 2020)
    ApiCategoryDefinition:
      type: object
      properties:
        description:
          type: string
          description: The description of the category
        dynamicValues:
          type: boolean
          description: Whether the category authorizes dynamic values
        folder:
          type: boolean
          description: Whether the category is the Folder category (read-only)
        id:
          type: string
          description: The ID of the category
        kind:
          type: string
        levelNames:
          type: array
          description: The name of the levels in the category
          items:
            type: string
        levelNames_i18n:
          type: array
          description: >-
            The internationalized name of the levels in the category (read-only
            field)
          items:
            type: string
        libraryId:
          type: string
          description: The ID of the library
        name:
          type: string
          description: The name of the category
        tags:
          type: boolean
          description: Whether the category is the Tags category (read-only)
        value:
          type: string
          description: >-
            The ID of the category (backward compatibility for
            category.category.listCategoryDefinitions)
    ApiCategoryValueMappingRef:
      type: object
      properties:
        displayName:
          type: string
          description: The display name of the mapping (read-only)
        id:
          type: string
          description: The ID of the category value mapping
    ApiClassTableColumn:
      type: object
      properties:
        appMetadata:
          type: object
          description: >-
            App Metadata let developers associate metadata with various
            configuration entities. The metadata is isolated within app
            namespaces in order to prevent one application from interfering with
            another's metadata.
          additionalProperties:
            $ref: '#/components/schemas/ApiNamespacedAppMetadata'
        calculatedSettings:
          type: object
          description: The configuration of calculated settings (mandatory/hidden)
          additionalProperties:
            $ref: '#/components/schemas/ApiCalculatedSettingConfiguration'
        calculatedValue:
          $ref: '#/components/schemas/ApiCalculatedValueConfiguration'
        categoryDefinition:
          $ref: '#/components/schemas/ApiCategoryDefinition'
        categoryId:
          type: string
          description: >-
            The ID of the category (if type = CATEGORY) - (deprecated,
            read-only)
        categoryValueMapping:
          $ref: '#/components/schemas/ApiCategoryValueMappingRef'
        columns:
          type: array
          description: >-
            The column properties of the field (only if this field is a table
            type field)
          items:
            $ref: '#/components/schemas/ApiClassTableColumn'
        creationSettings:
          $ref: '#/components/schemas/ApiDocumentFieldFlags'
        customPlaceholder:
          type: boolean
          description: >-
            Whether to use a custom placeholder when displaying the field in the
            UI
        description:
          type: string
          description: The description of the field
        displayInPreview:
          type: object
          description: The display in preview configuration of the field
          additionalProperties:
            $ref: '#/components/schemas/ApiDisplayInPreviewConfiguration'
        displayName:
          type: string
          description: The name of the field
        dynamicValues:
          type: boolean
        folder:
          type: boolean
        hidden:
          type: boolean
          description: >-
            Whether the field should be hidden for the whole life-cycle of
            documents of the class
        id:
          type: string
          description: The ID of the field (read-only field)
        kind:
          type: string
        levelNames:
          type: array
          items:
            type: string
        lookupConfiguration:
          $ref: '#/components/schemas/ApiLookupConfiguration'
        mandatory:
          type: boolean
          description: >-
            Whether the field should be mandatory for the whole life-cycle of
            documents of the class (not compatible for all field types)
        mappingSourceField:
          $ref: '#/components/schemas/ApiFieldRef'
        multiple:
          type: boolean
          description: >-
            Whether the field should be multi-valued (not compatible for all
            field types)
        placeholderText:
          type: string
          description: The placeholder text if customPlaceholder = true
        rank:
          type: integer
          format: int32
          description: The rank of the field in the list (deprecated)
        readOnly:
          type: boolean
          description: >-
            Whether the field should be read-only for the whole life-cycle of
            documents of the class (not compatible for all field types)
        referenceCatalog:
          $ref: '#/components/schemas/ApiReferenceCatalog'
        referenceCatalogId:
          type: string
          description: The ID of the reference catalog (if type = REFERENCE_CATALOG)
        type:
          type: string
          description: >-
            The type of field (STRING, TEXT, DATE, TIME, DATETIME, INTEGER,
            DECIMAL, BOOLEAN, PERSON, GEOPOINT, URL, CATEGORY,
            REFERENCE_CATALOG, TABLE)
          enum:
            - STRING
            - TEXT
            - DATE
            - TIME
            - DATETIME
            - INTEGER
            - FILESIZE
            - DECIMAL
            - BOOLEAN
            - PERSON
            - CATEGORY
            - GEOPOINT
            - URL
            - REFERENCE_CATALOG
            - MIMETYPEGROUP
            - CLASS
            - FOLDER
            - STATE
            - OSS_ATTACHMENT
            - DRIVE_ATTACHMENT
            - TABLE
        validation:
          $ref: '#/components/schemas/ApiFieldValidation'
    ApiDocumentFieldFlags:
      type: object
      properties:
        hidden:
          type: boolean
          description: Whether the field should be hidden during document creation only
        mandatory:
          type: boolean
          description: >-
            Whether the field should be mandatory during document creation only
            (not compatible for all field types)
        readOnly:
          type: boolean
          description: >-
            Whether the field should be read-only during document creation only
            (not compatible for all field types)
    ApiDisplayInPreviewConfiguration:
      type: object
      properties:
        order:
          type: integer
          format: int32
          description: The display order of this property in the consumer's preview.
        show:
          type: boolean
          description: Whether this property is displayed in the consumer's preview.
    ApiLookupConfiguration:
      type: object
      properties:
        sourceConfiguration:
          $ref: '#/components/schemas/ApiLookupSourceConfiguration'
        targetConfiguration:
          $ref: '#/components/schemas/ApiLookupTargetConfiguration'
    ApiFieldRef:
      type: object
      properties:
        displayName:
          type: string
          description: The display name of the field (read-only)
        id:
          type: string
          description: The ID of the field
    ApiReferenceCatalog:
      type: object
      properties:
        createdAt:
          type: integer
          format: int64
          description: >-
            The timestamp (in ms) at which the catalog was created (read-only
            field)
        id:
          type: string
          description: The ID of the reference catalog (read-only field)
        kind:
          type: string
        levelNames:
          type: array
          description: Ordered name of levels of the reference catalog
          items:
            type: string
        modifiedAt:
          type: integer
          format: int64
          description: >-
            The timestamp (in ms) at which the catalog was last modified
            (read-only field)
        name:
          type: string
          description: The name of the reference catalog
        numberOfValues:
          type: integer
          format: int32
          description: The number of values in the reference catalog (read-only field)
    ApiFieldValidation:
      type: object
      properties:
        audience:
          $ref: '#/components/schemas/ApiSecurityToken'
        errorMessage:
          type: string
          description: The error message if the value inputted is not valid
        kind:
          type: string
        lowerLimit:
          type: number
          format: double
          description: The lower limit of the range for numerical fields
        lowerLimitInclusive:
          type: boolean
          description: Whether to include the lower limit value in the range
        mandatoryLeaf:
          type: boolean
          description: >-
            Whether the leaf selection is required for Category or Reference
            Catalog fields
        regex:
          type: string
          description: The regular expression for String fields
        upperLimit:
          type: number
          format: double
          description: The upper limit of the range for numerical fields
        upperLimitInclusive:
          type: boolean
          description: Whether to include the upper limit value in the range
    ApiAppMetadataTag:
      type: object
      properties:
        kind:
          type: string
        name:
          type: string
          description: The name of the tag
        stringValue:
          type: string
          description: The value of the tag as a String
    ApiLookupSourceConfiguration:
      type: object
      properties:
        displaySearchProperties:
          type: array
          description: >-
            List of field IDs from the referenced class to be displayed in
            lookup search results. Valid values are custom field IDs or '_title'
            for the system title field.
          items:
            type: string
        freezeStates:
          type: array
          description: >-
            Workflow state IDs during which the lookup target(s) freeze and do
            not synchronize with the referenced field. Required when
            synchronizationRule is FREEZE_ON_STATE.
          items:
            type: string
        scope:
          $ref: '#/components/schemas/ApiLookupSourceScope'
        synchronizationRule:
          type: string
          description: >-
            Synchronization rule for the lookup source. Supported values: NEVER,
            ALWAYS, FREEZE_ON_STATE
          enum:
            - NEVER
            - ALWAYS
            - FREEZE_ON_STATE
        type:
          type: string
          description: 'Type of the lookup source configuration. Supported types: DOCUMENT'
          enum:
            - DOCUMENT
    ApiLookupTargetConfiguration:
      type: object
      properties:
        lookupKey:
          type: string
          description: >-
            Key of the lookup target configuration. Used to get the value from
            the referenced resource (e.g.: existing fieldId of the class defined
            in the source lookup
        sourceFieldId:
          type: string
          description: Identifier of the lookup source field
        sourceFieldName:
          type: string
          description: >-
            Name of the lookup source field. Can be used to refer the field by
            name when ID is not allocated yet (e.g.: along with source field
            creation)
    ApiSecurityToken:
      type: object
      properties:
        classId:
          type: string
          description: The ID of the class when type = FIELD
        className:
          type: string
          description: The name of the class when type = FIELD
        description:
          type: string
          description: The description for type in GROUP, ROLE, FIELD
        displayName:
          type: string
          description: >-
            The display name of the user or group, the name of the role
            (read-only field)
        displayName_i18n:
          type: string
          description: >-
            The display name of the user or group, the internationalized name of
            the role (read-only field)
        thumbnailPictureUrl:
          type: string
          description: The URL of the thumbnail picture (especially for users)
        type:
          type: string
          description: >-
            The type of person (user, group, role, field based, domain i.e.
            everybody)
          enum:
            - USER
            - GROUP
            - ROLE
            - FIELD
            - DOMAIN
        value:
          type: string
          description: >-
            The email address if user or group, the ID of the role, the ID of
            the class/field (ignored if type = DOMAIN)
    ApiLookupSourceScope:
      type: object
      properties:
        id:
          type: string
          description: >-
            Identifier of the lookup source scope configuration (e.g.: document
            class ID when the type is CLASS
        type:
          type: string
          description: >-
            Type of the lookup source scope configuration. Supported types:
            CLASS
          enum:
            - CLASS
  securitySchemes:
    google_id_token-a99f12e0:
      type: oauth2
      x-google-issuer: https://accounts.google.com
      x-google-jwks_uri: https://www.googleapis.com/oauth2/v1/certs
      x-google-audiences: >-
        755040865326-h5gomu85549lkh2qf9d3lku39vnaf6ii.apps.googleusercontent.com,563231141203-231sn7f6ptedncun5h00h7ktbe3o2nd5.apps.googleusercontent.com,993707107224.apps.googleusercontent.com,ao-docs,aodocs-core-eu-1,ao-docs-staging,ao-docs-dev,aodocs-core-dev-us,aodocs-total-poc-euw3
      flows:
        implicit:
          authorizationUrl: https://accounts.google.com/o/oauth2/v2/auth
          scopes:
            https://www.googleapis.com/auth/userinfo.email: View your email address
    google_id_token_legacy-a99f12e0:
      type: oauth2
      x-google-issuer: accounts.google.com
      x-google-jwks_uri: https://www.googleapis.com/oauth2/v1/certs
      x-google-audiences: >-
        755040865326-h5gomu85549lkh2qf9d3lku39vnaf6ii.apps.googleusercontent.com,563231141203-231sn7f6ptedncun5h00h7ktbe3o2nd5.apps.googleusercontent.com,993707107224.apps.googleusercontent.com,ao-docs,aodocs-core-eu-1,ao-docs-staging,ao-docs-dev,aodocs-core-dev-us,aodocs-total-poc-euw3
      flows:
        implicit:
          authorizationUrl: https://accounts.google.com/o/oauth2/v2/auth
          scopes:
            https://www.googleapis.com/auth/userinfo.email: View your email address

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.